SoVRMLTransform Class Reference
VRML97 Classes

The SoVRMLTransform class is a grouping node that defines a transformation for its children. More...

`#include <Inventor/VRMLnodes/SoVRMLTransform.h>`

Inheritance diagram for SoVRMLTransform:

## Public Member Functions

virtual SoType | getTypeId (void) const
| SoVRMLTransform (void)
| SoVRMLTransform (int children)
void | pointAt (const SbVec3f &from, const SbVec3f &to)
void | getScaleSpaceMatrix (SbMatrix &matrix, SbMatrix &inverse) const
void | getRotationSpaceMatrix (SbMatrix &matrix, SbMatrix &inverse) const
void | getTranslationSpaceMatrix (SbMatrix &matrix, SbMatrix &inverse) const
void | multLeft (const SbMatrix &matrix)
void | multRight (const SbMatrix &matrix)
void | combineLeft (SoVRMLTransform *leftnode)
void | combineRight (SoVRMLTransform *rightnode)
void | setMatrix (const SbMatrix &matrix)
void | recenter (const SbVec3f &newcenter)
virtual void | doAction (SoAction *action)
virtual void | callback (SoCallbackAction *action)
virtual void | getBoundingBox (SoGetBoundingBoxAction *action)
virtual void | getMatrix (SoGetMatrixAction *action)
virtual void | rayPick (SoRayPickAction *action)
virtual void | getPrimitiveCount (SoGetPrimitiveCountAction *action)
virtual void | audioRender (SoAudioRenderAction *action)
virtual void | GLRenderBelowPath (SoGLRenderAction *action)
virtual void | GLRenderInPath (SoGLRenderAction *action)
virtual void | notify (SoNotList *list)
Public Member Functions inherited from SoVRMLGroup
| SoVRMLGroup (void)
| SoVRMLGroup (int numChildren)
virtual void | GLRender (SoGLRenderAction *action)
virtual void | search (SoSearchAction *action)
virtual void | write (SoWriteAction *action)
virtual void | GLRenderOffPath (SoGLRenderAction *action)
Public Member Functions inherited from SoVRMLParent
virtual SbBool | affectsState (void) const
virtual void | addChild (SoNode *child)
virtual void | insertChild (SoNode *child, int idx)
virtual SoNode * | getChild (int idx) const
virtual int | findChild (const SoNode *child) const
virtual int | getNumChildren (void) const
virtual void | removeChild (int idx)
virtual void | removeChild (SoNode *child)
virtual void | removeAllChildren (void)
virtual void | replaceChild (int idx, SoNode *child)
virtual void | replaceChild (SoNode *old, SoNode *child)
virtual SoChildList * | getChildren (void) const
Public Member Functions inherited from SoGroup
| SoGroup (void)
| SoGroup (int nchildren)
virtual void | handleEvent (SoHandleEventAction *action)
virtual void | pick (SoPickAction *action)
virtual void | addWriteReference (SoOutput *out, SbBool isfromfield=FALSE)
Public Member Functions inherited from SoNode
void | setOverride (const SbBool state)
SbBool | isOverride (void) const
void | setNodeType (const NodeType type)
NodeType | getNodeType (void) const
virtual SoNode * | copy (SbBool copyconnections=FALSE) const
virtual void | grabEventsSetup (void)
virtual void | grabEventsCleanup (void)
virtual void | startNotify (void)
SbUniqueId | getNodeId (void) const
virtual void | writeInstance (SoOutput *out)
virtual SoNode * | addToCopyDict (void) const
virtual SoFieldContainer * | copyThroughConnection (void) const
Public Member Functions inherited from SoFieldContainer
void | setToDefaults (void)
SbBool | hasDefaultValues (void) const
SbBool | fieldsAreEqual (const SoFieldContainer *container) const
void | copyFieldValues (const SoFieldContainer *container, SbBool copyconnections=FALSE)
SbBool | set (const char *const fielddata)
void | get (SbString &fielddata)
virtual int | getFields (SoFieldList &l) const
virtual int | getAllFields (SoFieldList &l) const
virtual SoField * | getField (const SbName &name) const
virtual SoField * | getEventIn (const SbName &name) const
virtual SoField * | getEventOut (const SbName &name) const
SbBool | getFieldName (const SoField *const field, SbName &name) const
SbBool | enableNotify (const SbBool flag)
SbBool | isNotifyEnabled (void) const
SbBool | set (const char *fielddata, SoInput *input)
void | get (SbString &fielddata, SoOutput *out)
virtual SbBool | validateNewFieldValue (SoField *field, void *newval)
SbBool | getIsBuiltIn (void) const
virtual void | getFieldsMemorySize (size_t &managed, size_t &unmanaged) const
void | setUserData (void *userdata) const
void * | getUserData (void) const
Public Member Functions inherited from SoBase
void | ref (void) const
void | unref (void) const
void | unrefNoDelete (void) const
int32_t | getRefCount (void) const
void | touch (void)
SbBool | isOfType (SoType type) const
| Returns `TRUE` if the type of this object is either of the same type or inherited from type.
virtual SbName | getName (void) const
virtual void | setName (const SbName &newname)
void | addAuditor (void *const auditor, const SoNotRec::Type type)
void | removeAuditor (void *const auditor, const SoNotRec::Type type)
const SoAuditorList & | getAuditors (void) const
SbBool | shouldWrite (void)
void | assertAlive (void) const

## Static Public Member Functions

static SoType | getClassTypeId (void)
static void | initClass (void)
Static Public Member Functions inherited from SoVRMLGroup
static SoType | getClassTypeId (void)
static void | initClass (void)
static void | setNumRenderCaches (int num)
static int | getNumRenderCaches (void)
Static Public Member Functions inherited from SoVRMLParent
static SoType | getClassTypeId (void)
static void | initClass (void)
static void | updateChildList (const SoNode *const *nodes, const int numnodes, SoChildList &cl)
static void | updateChildList (SoNode *nodewithsfnode, SoChildList &cl)
Static Public Member Functions inherited from SoGroup
static SoType | getClassTypeId (void)
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
Static Public Member Functions inherited from SoNode
static uint32_t | getCompatibilityTypes (const SoType &nodetype)
static SoType | getClassTypeId (void)
static SoNode * | getByName (const SbName &name)
static int | getByName (const SbName &name, SoNodeList &l)
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static void | initClasses (void)
static SbUniqueId | getNextNodeId (void)
static int | getActionMethodIndex (const SoType type)
static void | getBoundingBoxS (SoAction *action, SoNode *node)
static void | GLRenderS (SoAction *action, SoNode *node)
static void | callbackS (SoAction *action, SoNode *node)
static void | getMatrixS (SoAction *action, SoNode *node)
static void | handleEventS (SoAction *action, SoNode *node)
static void | pickS (SoAction *action, SoNode *node)
static void | rayPickS (SoAction *action, SoNode *node)
static void | searchS (SoAction *action, SoNode *node)
static void | writeS (SoAction *action, SoNode *node)
static void | audioRenderS (SoAction *action, SoNode *node)
static void | getPrimitiveCountS (SoAction *action, SoNode *node)
Static Public Member Functions inherited from SoFieldContainer
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static SoType | getClassTypeId (void)
| This static method returns the SoType object associated with objects of this class.
static void | cleanupClass (void)
static void | initCopyDict (void)
static void | addCopy (const SoFieldContainer *orig, const SoFieldContainer *copy)
static SoFieldContainer * | checkCopy (const SoFieldContainer *orig)
static SoFieldContainer * | findCopy (const SoFieldContainer *orig, const SbBool copyconnections)
static void | copyDone (void)
Static Public Member Functions inherited from SoBase
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static SoType | getClassTypeId (void)
| This static method returns the SoType object associated with objects of this class.
static void | addName (SoBase *const base, const char *const name)
static void | removeName (SoBase *const base, const char *const name)
static void | incrementCurrentWriteCounter (void)
static void | decrementCurrentWriteCounter (void)
static SoBase * | getNamedBase (const SbName &name, SoType type)
static int | getNamedBases (const SbName &name, SoBaseList &baselist, SoType type)
static SbBool | read (SoInput *input, SoBase *&base, SoType expectedtype)
static void | setInstancePrefix (const SbString &c)
static void | setTraceRefs (SbBool trace)
static SbBool | getTraceRefs (void)
static SbBool | connectRoute (SoInput *input, const SbName &fromnodename, const SbName &fromfieldname, const SbName &tonodename, const SbName &tofieldname)
static SbBool | readRoute (SoInput *input)

## Public Attributes

SoSFVec3f | translation
SoSFRotation | rotation
SoSFVec3f | scale
SoSFRotation | scaleOrientation
SoSFVec3f | center
Public Attributes inherited from SoVRMLGroup
SoSFEnum | renderCaching
SoSFEnum | boundingBoxCaching
SoSFEnum | renderCulling
SoSFEnum | pickCulling
SoSFVec3f | bboxCenter
SoSFVec3f | bboxSize
Public Attributes inherited from SoVRMLParent
SoMFNode | children

## Protected Member Functions

virtual const SoFieldData * | getFieldData (void) const
virtual | ~SoVRMLTransform ()
Protected Member Functions inherited from SoVRMLGroup
virtual | ~SoVRMLGroup ()
virtual SbBool | cullTest (SoState *state)
Protected Member Functions inherited from SoVRMLParent
| SoVRMLParent (void)
| SoVRMLParent (int approxchildren)
virtual | ~SoVRMLParent ()
virtual SbBool | readInstance (SoInput *in, unsigned short flags)
virtual void | copyContents (const SoFieldContainer *from, SbBool copyConn)
Protected Member Functions inherited from SoGroup
virtual | ~SoGroup ()
virtual SbBool | readChildren (SoInput *in)
virtual SoNotRec | createNotRec (void)
void | setOperation (const SoNotRec::OperationType opType=SoNotRec::UNSPECIFIED, const SoNode *cc=NULL, const SoNode *pc=NULL, const int ci=-1)
Protected Member Functions inherited from SoNode
| SoNode (void)
virtual | ~SoNode ()
Protected Member Functions inherited from SoFieldContainer
| SoFieldContainer (void)
virtual | ~SoFieldContainer ()
Protected Member Functions inherited from SoBase
| SoBase (void)
virtual | ~SoBase ()
virtual void | destroy (void)
SbBool | hasMultipleWriteRefs (void) const
SbBool | writeHeader (SoOutput *out, SbBool isgroup, SbBool isengine) const
void | writeFooter (SoOutput *out) const
virtual const char * | getFileFormatName (void) const

## Static Protected Member Functions

static const SoFieldData ** | getFieldDataPtr (void)
Static Protected Member Functions inherited from SoVRMLGroup
static const SoFieldData ** | getFieldDataPtr (void)
Static Protected Member Functions inherited from SoVRMLParent
static const SoFieldData ** | getFieldDataPtr (void)
Static Protected Member Functions inherited from SoGroup
static const SoFieldData ** | getFieldDataPtr (void)
Static Protected Member Functions inherited from SoNode
static const SoFieldData ** | getFieldDataPtr (void)
static void | setNextActionMethodIndex (int index)
static int | getNextActionMethodIndex (void)
static void | incNextActionMethodIndex (void)
static void | setCompatibilityTypes (const SoType &nodetype, const uint32_t bitmask)
Static Protected Member Functions inherited from SoBase
static uint32_t | getCurrentWriteCounter (void)
static void | staticDataLock (void)
static void | staticDataUnlock (void)

## Additional Inherited Members

Public Types inherited from SoVRMLGroup
enum | CacheEnabled { OFF , ON , AUTO }
Public Types inherited from SoNode

enum

NodeType {
INVENTOR = 0x0000 , VRML1 = 0x0001 , VRML2 = 0x0002 , INVENTOR_1 = 0x0004 ,
INVENTOR_2_0 = 0x0008 , INVENTOR_2_1 = 0x0010 , INVENTOR_2_5 = 0x0020 , INVENTOR_2_6 = 0x0040 ,
COIN_1_0 = 0x0080 , COIN_2_0 = 0x0100 , EXTENSION = 0x0200 , COIN_2_2 = 0x0400 ,
COIN_2_3 = 0x0800 , COIN_2_4 = 0x1000 , INVENTOR_5_0 = 0x2000 , COIN_2_5 = 0x4000 ,
COIN_3_0 = 0x8000 , INVENTOR_6_0 = 0x10000 , COIN_4_0 = 0x20000
}

Protected Types inherited from SoBase
enum | BaseFlags { IS_ENGINE = 0x01 , IS_GROUP = 0x02 }
Protected Attributes inherited from SoVRMLParent
SoMFNode | addChildren
SoMFNode | removeChildren
Protected Attributes inherited from SoGroup
SoChildList * | children
Protected Attributes inherited from SoNode
SbUniqueId | uniqueId
Protected Attributes inherited from SoFieldContainer
SbBool | isBuiltIn
Static Protected Attributes inherited from SoVRMLGroup
static int | numRenderCaches = 2
Static Protected Attributes inherited from SoNode
static SbUniqueId | nextUniqueId = 1
static int | nextActionMethodIndex = 0

## Detailed Description

The SoVRMLTransform class is a grouping node that defines a transformation for its children.

The detailed class documentation is taken verbatim from the VRML97 standard (ISO/IEC 14772-1:1997). It is copyright The Web3D Consortium, and is used by permission of the Consortium:

    Transform {
      eventIn      MFNode      addChildren
      eventIn      MFNode      removeChildren
      exposedField SFVec3f     center           0 0 0    # (-inf,inf)
      exposedField MFNode      children         []
      exposedField SFRotation  rotation         0 0 1 0  # [-1,1],(-inf,inf)
      exposedField SFVec3f     scale            1 1 1    # (0,inf)
      exposedField SFRotation  scaleOrientation 0 0 1 0  # [-1,1],(-inf,inf)
      exposedField SFVec3f     translation      0 0 0    # (-inf,inf)
      field        SFVec3f     bboxCenter       0 0 0    # (-inf,inf)
      field        SFVec3f     bboxSize         -1 -1 -1 # (0,inf) or -1,-1,-1
    }

The Transform node is a grouping node that defines a coordinate system for its children that is relative to the coordinate systems of its ancestors. See 4.4.4, Transformation hierarchy (/documents/specifications/14772/V2.0/part1/concepts.html#4.4.4), and 4.4.5, Standard units and coordinate system (/documents/specifications/14772/V2.0/part1/concepts.html#4.4.5), for a description of coordinate systems and transformations.

4.6.5, Grouping and children nodes (/documents/specifications/14772/V2.0/part1/concepts.html#4.6.5), provides a description of the children, addChildren, and removeChildren fields and eventIns.

The bboxCenter and bboxSize fields specify a bounding box that encloses the children of the Transform node. This is a hint that may be used for optimization purposes. The results are undefined if the specified bounding box is smaller than the actual bounding box of the children at any time. A default bboxSize value, (-1, -1, -1), implies that the bounding box is not specified and, if needed, shall be calculated by the browser. The bounding box shall be large enough at all times to enclose the union of the group's children's bounding boxes; it shall not include any transformations performed by the group itself (i.e., the bounding box is defined in the local coordinate system of the children). The results are undefined if the specified bounding box is smaller than the true bounding box of the group. A description of the bboxCenter and bboxSize fields is provided in 4.6.4, Bounding boxes (/documents/specifications/14772/V2.0/part1/concepts.html#4.6.4).

The translation, rotation, scale, scaleOrientation and center fields define a geometric 3D transformation consisting of (in order):

- a (possibly) non-uniform scale about an arbitrary point;
- a rotation about an arbitrary point and axis;
- a translation.

The center field specifies a translation offset from the origin of the local coordinate system (0,0,0). The rotation field specifies a rotation of the coordinate system. The scale field specifies a non-uniform scale of the coordinate system. scale values shall be greater than zero. The scaleOrientation specifies a rotation of the coordinate system before the scale (to specify scales in arbitrary orientations). The scaleOrientation applies only to the scale operation. The translation field specifies a translation to the coordinate system.

Given a 3-dimensional point P and Transform node, P is transformed into point P' in its parent's coordinate system by a series of intermediate transformations. In matrix transformation notation, where C (center), SR (scaleOrientation), T (translation), R (rotation), and S (scale) are the equivalent transformation matrices,

    P' = T × C × R × SR × S × -SR × -C × P

The following Transform node:

    Transform {
      center           C
      rotation         R
      scale            S
      scaleOrientation SR
      translation      T
      children         [...]
    }

is equivalent to the nested sequence of:

    Transform {
      translation T
      children Transform {
        translation C
        children Transform {
          rotation R
          children Transform {
            rotation SR
            children Transform {
              scale S
              children Transform {
                rotation -SR
                children Transform {
                  translation -C
                  children [...]
                }
              }
            }
          }
        }
      }
    }

## Constructor & Destructor Documentation

## SoVRMLTransform() [1/2]

SoVRMLTransform::SoVRMLTransform | ( | void |  | ) |

Constructor.

## SoVRMLTransform() [2/2]

SoVRMLTransform::SoVRMLTransform | ( | int | numchildren | ) |

Constructor. numchildren is the expected number of children.

## ~SoVRMLTransform()

SoVRMLTransform::~SoVRMLTransform | ( |  | ) |

protected virtual

Destructor

## Member Function Documentation

## getClassTypeId()

SoType SoVRMLTransform::getClassTypeId | ( | void |  | ) |

static

This static method returns the SoType object associated with objects of this class.

## getTypeId()

SoType SoVRMLTransform::getTypeId | ( | void |  | ) | const

virtual

Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and "downward" casting.

Reimplemented from SoVRMLGroup.

## getFieldDataPtr()

const SoFieldData ** SoVRMLTransform::getFieldDataPtr | ( | void |  | ) |

static protected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
Returns the SoFieldData class which holds information about fields in this node.

## getFieldData()

const SoFieldData * SoVRMLTransform::getFieldData | ( | void |  | ) | const

protected virtual

Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns `NULL`.

Reimplemented from SoVRMLGroup.

## initClass()

void SoVRMLTransform::initClass | ( | void |  | ) |

static

## pointAt()

void SoVRMLTransform::pointAt | ( | const SbVec3f & | from,
|  | const SbVec3f & | to )

Sets the transformation to translate to frompoint, with a rotation so that the (0,0,-1) vector is rotated into the vector from frompoint to topoint.

## getScaleSpaceMatrix()

void SoVRMLTransform::getScaleSpaceMatrix | ( | SbMatrix & | matrix,
|  | SbMatrix & | inverse ) const

Calculates the matrices to/from scale space.

## getRotationSpaceMatrix()

void SoVRMLTransform::getRotationSpaceMatrix | ( | SbMatrix & | matrix,
|  | SbMatrix & | inverse ) const

Calculates the matrices to/from rotation space.

## getTranslationSpaceMatrix()

void SoVRMLTransform::getTranslationSpaceMatrix | ( | SbMatrix & | matrix,
|  | SbMatrix & | inverse ) const

Calculates the matrices to/from translation space.

## multLeft()

void SoVRMLTransform::multLeft | ( | const SbMatrix & | matrix | ) |

Premultiplies this transformation by mat.

## multRight()

void SoVRMLTransform::multRight | ( | const SbMatrix & | matrix | ) |

Postmultiplies this transformation by mat.

## combineLeft()

void SoVRMLTransform::combineLeft | ( | SoVRMLTransform * | leftnode | ) |

Premultiplies this transformation by the transformation in leftnode.

## combineRight()

void SoVRMLTransform::combineRight | ( | SoVRMLTransform * | rightnode | ) |

Postmultiplies this transformation by the transformation in rightnode.

## setMatrix()

void SoVRMLTransform::setMatrix | ( | const SbMatrix & | matrix | ) |

Sets the fields to create a transformation equal to mat.

## recenter()

void SoVRMLTransform::recenter | ( | const SbVec3f & | newcenter | ) |

Sets the center field to newcenter. This might affect one or more of the other fields.

## doAction()

void SoVRMLTransform::doAction | ( | SoAction * | action | ) |

virtual

This function performs the typical operation of a node for any action.

Reimplemented from SoVRMLGroup.

## callback()

void SoVRMLTransform::callback | ( | SoCallbackAction * | action | ) |

virtual

Action method for SoCallbackAction.

Simply updates the state according to how the node behaves for the render action, so the application programmer can use the SoCallbackAction for extracting information about the scene graph.

Reimplemented from SoVRMLGroup.

## getBoundingBox()

void SoVRMLTransform::getBoundingBox | ( | SoGetBoundingBoxAction * | action | ) |

virtual

Action method for the SoGetBoundingBoxAction.

Calculates bounding box and center coordinates for node and modifies the values of the action to encompass the bounding box for this node and to shift the center point for the scene more towards the one for this node.

Nodes influencing how geometry nodes calculate their bounding box also override this method to change the relevant state variables.

Reimplemented from SoVRMLGroup.

## getMatrix()

void SoVRMLTransform::getMatrix | ( | SoGetMatrixAction * | action | ) |

virtual

Action method for SoGetMatrixAction.

Updates action by accumulating with the transformation matrix of this node (if any).

Reimplemented from SoVRMLGroup.

## rayPick()

void SoVRMLTransform::rayPick | ( | SoRayPickAction * | action | ) |

virtual

Action method for SoRayPickAction.

Checks the ray specification of the action and tests for intersection with the data of the node.

Nodes influencing relevant state variables for how picking is done also override this method.

Reimplemented from SoVRMLGroup.

## getPrimitiveCount()

void SoVRMLTransform::getPrimitiveCount | ( | SoGetPrimitiveCountAction * | action | ) |

virtual

Action method for the SoGetPrimitiveCountAction.

Calculates the number of triangle, line segment and point primitives for the node and adds these to the counters of the action.

Nodes influencing how geometry nodes calculate their primitive count also override this method to change the relevant state variables.

Reimplemented from SoVRMLGroup.

## audioRender()

void SoVRMLTransform::audioRender | ( | SoAudioRenderAction * | action | ) |

virtual

Action method for SoAudioRenderAction.

Does common processing for SoAudioRenderAction action instances.

Reimplemented from SoVRMLGroup.

## GLRenderBelowPath()

void SoVRMLTransform::GLRenderBelowPath | ( | SoGLRenderAction * | action | ) |

virtual

Implements the SoAction::BELOW_PATH traversal method for the rendering action.

Reimplemented from SoVRMLGroup.

## GLRenderInPath()

void SoVRMLTransform::GLRenderInPath | ( | SoGLRenderAction * | action | ) |

virtual

Implements the SoAction::IN_PATH traversal method for the rendering action.

Reimplemented from SoVRMLGroup.

## notify()

void SoVRMLTransform::notify | ( | SoNotList * | l | ) |

virtual

Notifies all auditors for this instance when changes are made.

Reimplemented from SoVRMLGroup.

## Member Data Documentation

## translation

SoSFVec3f SoVRMLTransform::translation

The translation vector. Default value is (0, 0, 0).

## rotation

SoSFRotation SoVRMLTransform::rotation

The rotation around the center point. Default value is null-rotation.

## scale

SoSFVec3f SoVRMLTransform::scale

The scale vector about the center point. Default value is (1, 1, 1).

## scaleOrientation

SoSFRotation SoVRMLTransform::scaleOrientation

The scale orientation. Default value is a null-rotation.

## center

SoSFVec3f SoVRMLTransform::center

The center point. Default value is (0, 0, 0).

The documentation for this class was generated from the following files:

- SoVRMLTransform.h
- Transform.cpp